-----------------------------------------------------------------------------------------
-- Test a Scene for Compatibility
-----------------------------------------------------------------------------------------
function Battlegrounds:StartActivity()


  self.Area = SceneMan.Scene:GetArea("Battlegroundstest")
  
  self.Team1players = 0
	-- Player brains
	for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
		if self:GetTeamOfPlayer(player) == Activity.TEAM_1 and self:PlayerActive(player) and self:PlayerHuman(player) then
			local Brain = CreateActor("Brain Case", "Base.rte")
			Brain.Team = Activity.TEAM_1
      Brain.Pos = Vector(120, 876)
			MovableMan:AddActor(Brain)
			self:SetPlayerBrain(Brain, player)
			--self:SetObservationTarget(Brain.Pos, player)
			self.activePlayer = player
			FrameMan:ClearScreenText(player)
			FrameMan:SetScreenText("Crush the enemy base to clain victory!", player, 333, -1, false)
			self.Team1players = self.Team1players + 1
		end
	end
	
	self.Team2players = 0
	-- Player brains
	for player = Activity.PLAYER_2, Activity.MAXPLAYERCOUNT - 1 do
		if self:GetTeamOfPlayer(player) == Activity.TEAM_2 and self:PlayerActive(player) and self:PlayerHuman(player) then
			local Brain = CreateActor("Brain Case", "Base.rte")
			Brain.Team = Activity.TEAM_2
      Brain.Pos = Vector(4128, 876)
			MovableMan:AddActor(Brain)
			self:SetPlayerBrain(Brain, player)
			--self:SetObservationTarget(Brain.Pos, player)
			self.activePlayer = player
			FrameMan:ClearScreenText(player)
			FrameMan:SetScreenText("Crush the enemy base to clain victory!", player, 333, -1, false)
			self.Team2players = self.Team2players + 1
		end
	end
	
	self.FightingCPU = false
	self.Diff = 0
	
	if self.Team1players == 0 then
    self.CPUBrain = CreateActor("Brain Case", "Base.rte")
    self.CPUBrain.Team = Activity.TEAM_1
    self.CPUBrain.Pos = Vector(120, 876)
    MovableMan:AddActor(self.CPUBrain)
    self.CPUTeam = Activity.TEAM_1;
    self.FightingCPU = true
	end
	if self.Team2players == 0 then
    self.CPUBrain = CreateActor("Brain Case", "Base.rte")
    self.CPUBrain.Team = Activity.TEAM_2
    self.CPUBrain.Pos = Vector(4128, 876)
    MovableMan:AddActor(self.CPUBrain)
    self.CPUTeam = Activity.TEAM_2;
    self.FightingCPU = true
	end
	if self.FightingCPU == true then
    if self.Difficulty == GameActivity.CAKEDIFFICULTY then
      self.Diff = -12
    elseif self.Difficulty == GameActivity.EASYDIFFICULTY then
      self.Diff = -6
    elseif self.Difficulty == GameActivity.HARDDIFFICULTY then
      self.Diff = 4
    elseif self.Difficulty == GameActivity.NUTSDIFFICULTY then
      self.Diff = 8
    elseif self.Difficulty == GameActivity.MAXDIFFICULTY then
      self.Diff = 12
    end
	end
	self.Teleporterteam1leftarea = Vector(7960,1144)
	self.Teleporterteam1rightarea = Vector(232,1144)
	
	self.Teleporterteam2leftarea = Vector(3958,1144)
	self.Teleporterteam2rightarea = Vector(4240,1144)
	
	self.Generators = {};
	self.GeneratorsLight = {};
	self.GeneratorsHeavy = {};
	self.GeneratorsSniper = {};
	self.GeneratorsHeavyAssault = {};
	self.GeneratorsTimer = {};
	
  for i = 1 , 2 do
		self.Generators[i] = CreateMOSRotating("Clone Generator" , "Battlegrounds.rte");
		MovableMan:AddParticle(self.Generators[i]);
		self.GeneratorsLight[i] = 2
		self.GeneratorsHeavy[i] = 1
		self.GeneratorsSniper[i] = 1
		self.GeneratorsHeavyAssault[i] = 0.5
		self.GeneratorsTimer[i] = 0
		self.Generators[i].Team = 0
		if self.FightingCPU == true then
      if self.Team1players == 0 then
        if self.Difficulty == GameActivity.CAKEDIFFICULTY then
          self.GeneratorsLight[i] = self.GeneratorsLight[i] * 0.8
          self.GeneratorsHeavy[i] = self.GeneratorsHeavy[i] * 0.8
          self.GeneratorsSniper[i] = self.GeneratorsSniper[i] * 0.8
          self.GeneratorsHeavyAssault[i] = self.GeneratorsHeavyAssault[i] * 0.8
        elseif self.Difficulty == GameActivity.EASYDIFFICULTY then
          self.GeneratorsLight[i] = self.GeneratorsLight[i] * 0.9
          self.GeneratorsHeavy[i] = self.GeneratorsHeavy[i] * 0.9
          self.GeneratorsSniper[i] = self.GeneratorsSniper[i] * 0.9
          self.GeneratorsHeavyAssault[i] = self.GeneratorsHeavyAssault[i] * 0.9
        end
        if self.Difficulty == GameActivity.HARDDIFFICULTY then
          self.GeneratorsLight[i] = self.GeneratorsLight[i] * 1.05
          self.GeneratorsHeavy[i] = self.GeneratorsHeavy[i] * 1.05
          self.GeneratorsSniper[i] = self.GeneratorsSniper[i] * 1.05
          self.GeneratorsHeavyAssault[i] = self.GeneratorsHeavyAssault[i] * 1.05
        elseif self.Difficulty == GameActivity.NUTSDIFFICULTY then
          self.GeneratorsLight[i] = self.GeneratorsLight[i] * 1.15
          self.GeneratorsHeavy[i] = self.GeneratorsHeavy[i] * 1.15
          self.GeneratorsSniper[i] = self.GeneratorsSniper[i] * 1.15
          self.GeneratorsHeavyAssault[i] = self.GeneratorsHeavyAssault[i] * 1.15
        elseif self.Difficulty == GameActivity.MAXDIFFICULTY then
          self.GeneratorsLight[i] = self.GeneratorsLight[i] * 1.45
          self.GeneratorsHeavy[i] = self.GeneratorsHeavy[i] * 1.45
          self.GeneratorsSniper[i] = self.GeneratorsSniper[i] * 1.45
          self.GeneratorsHeavyAssault[i] = self.GeneratorsHeavyAssault[i] * 1.45
        end
      else
        if self.Difficulty == GameActivity.HARDDIFFICULTY then
          self.GeneratorsLight[i] = self.GeneratorsLight[i] * 0.9
          self.GeneratorsHeavy[i] = self.GeneratorsHeavy[i] * 0.9
          self.GeneratorsSniper[i] = self.GeneratorsSniper[i] * 0.9
          self.GeneratorsHeavyAssault[i] = self.GeneratorsHeavyAssault[i] * 0.9
        elseif self.Difficulty == GameActivity.NUTSDIFFICULTY then
          self.GeneratorsLight[i] = self.GeneratorsLight[i] * 0.8
          self.GeneratorsHeavy[i] = self.GeneratorsHeavy[i] * 0.8
          self.GeneratorsSniper[i] = self.GeneratorsSniper[i] * 0.8
          self.GeneratorsHeavyAssault[i] = self.GeneratorsHeavyAssault[i] * 0.8
        elseif self.Difficulty == GameActivity.MAXDIFFICULTY then
          self.GeneratorsLight[i] = self.GeneratorsLight[i] * 0.7
          self.GeneratorsHeavy[i] = self.GeneratorsHeavy[i] * 0.7
          self.GeneratorsSniper[i] = self.GeneratorsSniper[i] * 0.7
          self.GeneratorsHeavyAssault[i] = self.GeneratorsHeavyAssault[i] * 0.7
        end
      end
    end
	end

	self.Generators[1].Pos = Vector(7992, 1008);
	self.Generators[2].Pos = Vector(264, 1008);
	
  for i = 3 , 4 do
		self.Generators[i] = CreateMOSRotating("Clone Generator" , "Battlegrounds.rte");
		MovableMan:AddParticle(self.Generators[i]);
		self.GeneratorsLight[i] = 2
		self.GeneratorsHeavy[i] = 1
		self.GeneratorsSniper[i] = 1
		self.GeneratorsHeavyAssault[i] = 0.5
		self.GeneratorsTimer[i] = 0
		self.Generators[i].Team = 1
		if self.FightingCPU == true then
      if self.Team2players == 0 then
        if self.Difficulty == GameActivity.CAKEDIFFICULTY then
          self.GeneratorsLight[i] = self.GeneratorsLight[i] * 0.8
          self.GeneratorsHeavy[i] = self.GeneratorsHeavy[i] * 0.8
          self.GeneratorsSniper[i] = self.GeneratorsSniper[i] * 0.8
          self.GeneratorsHeavyAssault[i] = self.GeneratorsHeavyAssault[i] * 0.8
        elseif self.Difficulty == GameActivity.EASYDIFFICULTY then
          self.GeneratorsLight[i] = self.GeneratorsLight[i] * 0.9
          self.GeneratorsHeavy[i] = self.GeneratorsHeavy[i] * 0.9
          self.GeneratorsSniper[i] = self.GeneratorsSniper[i] * 0.9
          self.GeneratorsHeavyAssault[i] = self.GeneratorsHeavyAssault[i] * 0.9
        end
        if self.Difficulty == GameActivity.HARDDIFFICULTY then
          self.GeneratorsLight[i] = self.GeneratorsLight[i] * 1.05
          self.GeneratorsHeavy[i] = self.GeneratorsHeavy[i] * 1.05
          self.GeneratorsSniper[i] = self.GeneratorsSniper[i] * 1.05
          self.GeneratorsHeavyAssault[i] = self.GeneratorsHeavyAssault[i] * 1.05
        elseif self.Difficulty == GameActivity.NUTSDIFFICULTY then
          self.GeneratorsLight[i] = self.GeneratorsLight[i] * 1.15
          self.GeneratorsHeavy[i] = self.GeneratorsHeavy[i] * 1.15
          self.GeneratorsSniper[i] = self.GeneratorsSniper[i] * 1.15
          self.GeneratorsHeavyAssault[i] = self.GeneratorsHeavyAssault[i] * 1.15
        elseif self.Difficulty == GameActivity.MAXDIFFICULTY then
          self.GeneratorsLight[i] = self.GeneratorsLight[i] * 1.45
          self.GeneratorsHeavy[i] = self.GeneratorsHeavy[i] * 1.45
          self.GeneratorsSniper[i] = self.GeneratorsSniper[i] * 1.45
          self.GeneratorsHeavyAssault[i] = self.GeneratorsHeavyAssault[i] * 1.45
        end
      else
        if self.Difficulty == GameActivity.HARDDIFFICULTY then
          self.GeneratorsLight[i] = self.GeneratorsLight[i] * 0.9
          self.GeneratorsHeavy[i] = self.GeneratorsHeavy[i] * 0.9
          self.GeneratorsSniper[i] = self.GeneratorsSniper[i] * 0.9
          self.GeneratorsHeavyAssault[i] = self.GeneratorsHeavyAssault[i] * 0.9
        elseif self.Difficulty == GameActivity.NUTSDIFFICULTY then
          self.GeneratorsLight[i] = self.GeneratorsLight[i] * 0.8
          self.GeneratorsHeavy[i] = self.GeneratorsHeavy[i] * 0.8
          self.GeneratorsSniper[i] = self.GeneratorsSniper[i] * 0.8
          self.GeneratorsHeavyAssault[i] = self.GeneratorsHeavyAssault[i] * 0.8
        elseif self.Difficulty == GameActivity.MAXDIFFICULTY then
          self.GeneratorsLight[i] = self.GeneratorsLight[i] * 0.7
          self.GeneratorsHeavy[i] = self.GeneratorsHeavy[i] * 0.7
          self.GeneratorsSniper[i] = self.GeneratorsSniper[i] * 0.7
          self.GeneratorsHeavyAssault[i] = self.GeneratorsHeavyAssault[i] * 0.7
        end
      end
    end
	end

	self.Generators[3].Pos = Vector(3976, 1008);
	self.Generators[4].Pos = Vector(4272, 1008);


  --teleporter

	self.Teleporter = {};
	self.TeleporterTeam = {};
	--[[
  for actor in MovableMan.Particles do
    if actor.PresetName == "Teleporter Texture B" then
      self.Teleporter[#self.Teleporter + 1] = actor
    end
  end
  
  local iPos = 1
  local i = 1
  local iMin = 1
  while iPos < #self.Teleporter do
    iMin = iPos
    i = iPos+1
    while i < #self.Teleporter do
      if self.Teleporter[i].Pos.X < self.Teleporter[iMin].Pos.X then
        iMin = i
      end
      i = i + 1
    end
    if iMin ~= iPos then
      local swap = self.Teleporter[iPos]
      self.Teleporter[iPos] = self.Teleporter[iMin]
      self.Teleporter[iMin] = swap
    end
    iPos = iPos + 1
  end
  ]]--
	
  for i = 1 , 8 do
		self.Teleporter[i] = CreateAEmitter("Teleporter Texture B" , "Battlegrounds.rte");
		MovableMan:AddParticle(self.Teleporter[i]);
		self.TeleporterTeam[i] = 0
	end

	self.Teleporter[1].Pos = Vector(24, 240);
	self.TeleporterTeam[1] = 1
	self.Teleporter[2].Pos = Vector(216, 240);
	self.TeleporterTeam[2] = 1
	self.Teleporter[3].Pos = Vector(1752, 372);
	self.Teleporter[4].Pos = Vector(2892, 324);
	self.Teleporter[5].Pos = Vector(4032, 240);
	self.TeleporterTeam[5] = 2
	self.Teleporter[6].Pos = Vector(4224, 240);
	self.TeleporterTeam[6] = 2
	self.Teleporter[7].Pos = Vector(5784, 372);
	self.Teleporter[8].Pos = Vector(6900, 324);

	self.Flag = {};
	self.FlagPos = {};
	self.FlagsCounter = {};
	self.FlagsRequired1 = {};
	self.FlagsRequired2 = {};
	self.FlagsArea1 = {};
	self.FlagsArea2 = {};
	self.FlagsActive = {};
	
  for i = 1 , 8 do
		self.FlagsCounter[i] = 0
		self.FlagsActive[i] = false
		self.FlagsRequired1[i] = 1
		self.FlagsRequired2[i] = 6
    self.FlagsArea1[i] = 0
    self.FlagsArea2[i] = 0
	end
	
  self.Flag[3] = CreateAEmitter("Flag White" , "Battlegrounds.rte");
  MovableMan:AddParticle(self.Flag[3]);
  self.FlagPos[3] = Vector(1752, 302);
  
  self.Flag[4] = CreateAEmitter("Flag White" , "Battlegrounds.rte");
  MovableMan:AddParticle(self.Flag[4]);
  self.FlagPos[4] = Vector(2892, 252);
  
  self.Flag[7] = CreateAEmitter("Flag White" , "Battlegrounds.rte");
  MovableMan:AddParticle(self.Flag[7]);
  self.FlagPos[7] = Vector(5784, 302);
  
  self.Flag[8] = CreateAEmitter("Flag White" , "Battlegrounds.rte");
  MovableMan:AddParticle(self.Flag[8]);
  self.FlagPos[8] = Vector(6900, 252);
  
  self.FlagsCounter[1] = 1500
  self.FlagsCounter[2] = 1500
  self.FlagsCounter[5] = -1500
  self.FlagsCounter[6] = -1500
  self.FlagsCounter[3] = 0
  self.FlagsArea1[3] = Vector(1704, 492)
  self.FlagsArea2[3] = Vector(1800, 612)
  self.FlagsActive[3] = true
  self.FlagsRequired2[3] = 4
  self.FlagsCounter[4] = 0
  self.FlagsArea1[4] = Vector(2844, 516)
  self.FlagsArea2[4] = Vector(2940, 636)
  self.FlagsActive[4] = true
  self.FlagsRequired1[4] = 3

  self.FlagsCounter[7] = 0
  self.FlagsArea1[7] = Vector(5736, 492)
  self.FlagsArea2[7] = Vector(5832, 612)
  self.FlagsActive[7] = true
  self.FlagsRequired1[7] = 8
  self.FlagsCounter[8] = 0
  self.FlagsArea1[8] = Vector(6852, 516)
  self.FlagsArea2[8] = Vector(6948, 636)
  self.FlagsActive[8] = true
  self.FlagsRequired2[8] = 7

	ActivityMan:GetActivity():SetTeamFunds(0,Activity.TEAM_1)
  ActivityMan:GetActivity():SetTeamFunds(0,Activity.TEAM_2)
	
	self.LZ = SceneMan.Scene:GetArea("LZ Team 1")
	self.EnemyLZ = SceneMan.Scene:GetArea("LZ All")
	SceneMan:MakeAllUnseen(Vector(24, 24), Activity.TEAM_1);
	SceneMan:MakeAllUnseen(Vector(24, 24), Activity.TEAM_2);
	self.ScanEndPos = Vector()
    local posx = 0
    while posx < SceneMan.Scene.Width do
      SceneMan:CastSeeRay(Activity.TEAM_1, Vector(posx, 0), Vector(0, SceneMan.Scene.Height), self.ScanEndPos, 50, SceneMan:GetUnseenResolution(Activity.TEAM_1).Y / 2);
      if posx > 7920 or posx < 312 then
        SceneMan:CastSeeRay(Activity.TEAM_1, Vector(posx, 0), Vector(0, 1300), self.ScanEndPos, 50000, 24);
      end
      if posx == 7896 then
        SceneMan:CastSeeRay(Activity.TEAM_1, Vector(posx, 0), Vector(0, 700), self.ScanEndPos, 50000, 24);
      end
      if (posx > 7680 or posx < 648) and not (posx > 7920 or posx < 312) then
        SceneMan:CastSeeRay(Activity.TEAM_1, Vector(posx, 0), Vector(0, 550), self.ScanEndPos, 50000, 24);
      end
      posx = posx + 24
    end
  for team = Activity.TEAM_2, Activity.MAXTEAMCOUNT - 1 do

  end
    local posx = 0
    while posx < SceneMan.Scene.Width do
      SceneMan:CastSeeRay(Activity.TEAM_2, Vector(posx, 0), Vector(0, SceneMan.Scene.Height), self.ScanEndPos, 50, SceneMan:GetUnseenResolution(Activity.TEAM_2).Y / 2);
      if posx > 3928 and posx < 4320 then
        SceneMan:CastSeeRay(Activity.TEAM_2, Vector(posx, 0), Vector(0, 1300), self.ScanEndPos, 50000, 24);
      end
      if posx == 3888 then
        SceneMan:CastSeeRay(Activity.TEAM_2, Vector(posx, 0), Vector(0, 700), self.ScanEndPos, 50000, 24);
      end
      if (posx > 3736 and posx < 4608) and not (posx > 7920 or posx < 312) then
        SceneMan:CastSeeRay(Activity.TEAM_2, Vector(posx, 0), Vector(0, 550), self.ScanEndPos, 50000, 24);
      end
      posx = posx + 24
    end
end

function Battlegrounds:Teleport(from , to , actor)
	--Teleport the actor.
	actor.Pos = to;
	actor.Vel.Y = 0;
	--Make the actor glow for a while.
	actor:FlashWhite(1500);
	--Create the teleportation effect for both teleporters in the set.
	local fxa = CreateAEmitter("Teleporter Effect A");
	fxa.Pos = from;
	MovableMan:AddParticle(fxa);
	local fxb = CreateAEmitter("Teleporter Effect B");
	fxb.Pos = to;
	MovableMan:AddParticle(fxb);
  actor.AIMode = Actor.AIMODE_GOTO;
  actor:ClearAIWaypoints();
  if actor.Team == 0 then
    actor:AddAISceneWaypoint(Vector(4128, 876));
  else
    actor:AddAISceneWaypoint(Vector(120, 876));
  end
end

function Battlegrounds:TeleportFindLeft(actor , team)
  local check = Vector(9000, 200)
  local team = nil
  local i = 7;
  while i ~= 6 do
--    if MovableMan:IsParticle(self.Teleporter[i]) and string.find(self.Teleporter[i].PresetName, "Teleporter Texture B") then
      if self.Teleporter[i].Pos.X < check.X and self.Teleporter[i].Pos.X > 4008 and self.TeleporterTeam[i] == 1 then
        check = self.Teleporter[i].Pos
        self:Teleport(actor.Pos,check,actor)
        break
      end
--    end
    i = i + 1
    if i == 9 then
      i = 1
    end
  end
  if check.X == 9000 then
    check = self.Teleporter[1].Pos
  end
  self:Teleport(actor.Pos,check,actor)
end

function Battlegrounds:TeleportFindRight(actor , team)
  local check = Vector(0, 200)
  local team = nil
  local i = 4;
  while i ~= 5 do
--    if MovableMan:IsParticle(self.Teleporter[i]) and string.find(self.Teleporter[i].PresetName, "Teleporter Texture B") then
      if self.Teleporter[i].Pos.X > check.X and self.Teleporter[i].Pos.X < 4008 and self.TeleporterTeam[i] == 1 then
        check = self.Teleporter[i].Pos
        self:Teleport(actor.Pos,check,actor)
        break
      end
--    end
    i = i - 1
    if i == 0 then
      i = 9
    end
  end
  self:Teleport(actor.Pos,check,actor)
end

function Battlegrounds:Teleport2FindLeft(actor , team)
  local check = Vector(9000, 200)
  local team = nil
  local i = 3;
  while i ~= 2 do
--    if MovableMan:IsParticle(self.Teleporter[i]) and string.find(self.Teleporter[i].PresetName, "Teleporter Texture B") then
      if self.Teleporter[i].Pos.X < check.X and self.Teleporter[i].Pos.X < 4040 and self.TeleporterTeam[i] == 2 then
        check = self.Teleporter[i].Pos
        self:Teleport(actor.Pos,check,actor)
        break
      end
--    end
    i = i + 1
    if i == 9 then
      i = 1
    end
  end
  self:Teleport(actor.Pos,check,actor)
end

function Battlegrounds:Teleport2FindRight(actor , team)
  local check = Vector(0, 200)
  local team = nil
  local i = 8;
  while i ~= 1 do
--    if MovableMan:IsParticle(self.Teleporter[i]) and string.find(self.Teleporter[i].PresetName, "Teleporter Texture B") then
      if self.Teleporter[i].Pos.X > check.X and self.Teleporter[i].Pos.X > 4008 and self.TeleporterTeam[i] == 2 then
        check = self.Teleporter[i].Pos
        self:Teleport(actor.Pos,check,actor)
        break
      end
--    end
    i = i - 1
    if i == 0 then
      i = 9
    end
  end
  self:Teleport(actor.Pos,check,actor)
end

function Battlegrounds:UpdateActivity()
  local i = 1;
  while i < 10 do
    --Flag check
    if self.FlagsActive[i] == true and MovableMan:IsParticle(self.Teleporter[i]) and string.find(self.Teleporter[i].PresetName, "Teleporter Texture B") then
      if self.FlagsCounter[i] > 200 then
        self.TeleporterTeam[i] = 1
      elseif self.TeleporterTeam[i] == 1 then
        self.FlagsCounter[i] = self.FlagsCounter[i] + 0.2
      end
      if self.FlagsCounter[i] < -200 then
        self.TeleporterTeam[i] = 2
      elseif self.TeleporterTeam[i] == 2 then
        self.FlagsCounter[i] = self.FlagsCounter[i] - 0.2
      end
      if self.TeleporterTeam[i] == 0 then
        if self.FlagsCounter[i] < -0.2 then
          self.FlagsCounter[i] = self.FlagsCounter[i] + 0.2
        end
        if self.FlagsCounter[i] > 0.2 then
          self.FlagsCounter[i] = self.FlagsCounter[i] - 0.2
        end
      end
      if self.FlagsCounter[i] < -10 and not string.find(self.Flag[i].PresetName, "Flag Green") then
        self.Flag[i].ToDelete = true
        self.Flag[i] = CreateAEmitter("Flag Green" , "Battlegrounds.rte");
        MovableMan:AddParticle(self.Flag[i]);
      end
      if self.FlagsCounter[i] > 10 and not string.find(self.Flag[i].PresetName, "Flag Red") then
        self.Flag[i].ToDelete = true
        self.Flag[i] = CreateAEmitter("Flag Red" , "Battlegrounds.rte");
        MovableMan:AddParticle(self.Flag[i]);
      end
      if self.FlagsCounter[i] < 10 and self.FlagsCounter[i] > -10 and not string.find(self.Flag[i].PresetName, "Flag White") then
        self.Flag[i].ToDelete = true
        self.Flag[i] = CreateAEmitter("Flag White" , "Battlegrounds.rte");
        MovableMan:AddParticle(self.Flag[i]);
        self.TeleporterTeam[i] = 0
      end
      if self.FlagsActive[i] == true then
        self.Flag[i].Pos = self.FlagPos[i] - Vector(0,math.abs(self.FlagsCounter[i]) * 0.4)
      end
    end
    --Spawner
    if MovableMan:IsParticle(self.Generators[i]) and string.find(self.Generators[i].PresetName, "Clone Generator") then
      local Spawnrate = self.GeneratorsLight[i] + self.GeneratorsHeavy[i] + self.GeneratorsSniper[i] + self.GeneratorsHeavyAssault[i]
      if Spawnrate ~= 0 then
        self.GeneratorsTimer[i] = self.GeneratorsTimer[i] - Spawnrate
        if self.GeneratorsTimer[i] < 0 then
          self.Generators[i].Frame = self.Generators[i].Frame + 1
          if self.Generators[i].Frame == 9 then
            self.Generators[i].Frame = 0
            
            --Spawn Random dude relative to the current upgrades researched
            local r = math.random(10, Spawnrate * 10)*0.1
            local actor = 0
--            if r <= self.GeneratorsLight[i] then
--              actor = CreateAHuman("Soldier Light","Battlegrounds.rte");
--              actor:AddInventoryItem(CreateHDFirearm("Assault Rifle","Battlegrounds.rte"));
--              --self.GeneratorsLight[i] = self.GeneratorsLight[i] - 1
--            elseif r <= self.GeneratorsLight[i]+self.GeneratorsHeavy[i] then
--              actor = CreateAHuman("Heavy Trooper","GreenStorm.rte");
--              actor:AddInventoryItem(CreateHDFirearm("Mauler Shotgun","Battlegrounds.rte"));
--              --self.GeneratorsHeavy[i] = self.GeneratorsHeavy[i] - 1
--            else
--              actor = CreateAHuman("Soldier Sniper","Battlegrounds.rte");
--              actor:AddInventoryItem(CreateHDFirearm("Sniper Rifle","Battlegrounds.rte"));
--              --self.GeneratorsSniper[i] = self.GeneratorsSniper[i] - 1
--            end
            if r <= self.GeneratorsLight[i] then
              actor = CreateAHuman("Soldier Light","Battlegrounds.rte");
              local weapon = "Compact Assault Rifle"
              local upgradedweapon = "Assault Rifle"
              
              if self.FightingCPU == true then
                if self.Generators[i].Team == 0 then
                  if self.Team1players == 0 then
                    if self.Diff >= math.random(0,12) then
                      actor:AddInventoryItem(CreateHDFirearm(upgradedweapon,"Battlegrounds.rte"));
                    else
                      actor:AddInventoryItem(CreateHDFirearm(weapon,"Battlegrounds.rte"));
                    end
                  else
                    if self.Diff * -1 >= math.random(0,12) then
                      actor:AddInventoryItem(CreateHDFirearm(upgradedweapon,"Battlegrounds.rte"));
                    else
                      actor:AddInventoryItem(CreateHDFirearm(weapon,"Battlegrounds.rte"));
                    end
                  end
                else
                  if self.Team2players == 0 then
                    if self.Diff >= math.random(0,12) then
                      actor:AddInventoryItem(CreateHDFirearm(upgradedweapon,"Battlegrounds.rte"));
                    else
                      actor:AddInventoryItem(CreateHDFirearm(weapon,"Battlegrounds.rte"));
                    end
                  else
                    if self.Diff * -1 >= math.random(0,12) then
                      actor:AddInventoryItem(CreateHDFirearm(upgradedweapon,"Battlegrounds.rte"));
                    else
                      actor:AddInventoryItem(CreateHDFirearm(weapon,"Battlegrounds.rte"));
                    end
                  end
                end
              else
                actor:AddInventoryItem(CreateHDFirearm(weapon,"Battlegrounds.rte"));
              end
              --self.GeneratorsLight[i] = self.GeneratorsLight[i] - 1
            elseif r <= self.GeneratorsLight[i]+self.GeneratorsHeavy[i] then
              actor = CreateAHuman("Soldier Heavy","Battlegrounds.rte");
              local weapon = "Shotgun"
              local upgradedweapon = "Mauler Shotgun"
              
              if self.FightingCPU == true then
                if self.Generators[i].Team == 0 then
                  if self.Team1players == 0 then
                    if self.Diff >= math.random(0,12) then
                      actor:AddInventoryItem(CreateHDFirearm(upgradedweapon,"Battlegrounds.rte"));
                    else
                      actor:AddInventoryItem(CreateHDFirearm(weapon,"Battlegrounds.rte"));
                    end
                  else
                    if self.Diff * -1 >= math.random(0,12) then
                      actor:AddInventoryItem(CreateHDFirearm(upgradedweapon,"Battlegrounds.rte"));
                    else
                      actor:AddInventoryItem(CreateHDFirearm(weapon,"Battlegrounds.rte"));
                    end
                  end
                else
                  if self.Team2players == 0 then
                    if self.Diff >= math.random(0,12) then
                      actor:AddInventoryItem(CreateHDFirearm(upgradedweapon,"Battlegrounds.rte"));
                    else
                      actor:AddInventoryItem(CreateHDFirearm(weapon,"Battlegrounds.rte"));
                    end
                  else
                    if self.Diff * -1 >= math.random(0,12) then
                      actor:AddInventoryItem(CreateHDFirearm(upgradedweapon,"Battlegrounds.rte"));
                    else
                      actor:AddInventoryItem(CreateHDFirearm(weapon,"Battlegrounds.rte"));
                    end
                  end
                end
              else
                actor:AddInventoryItem(CreateHDFirearm(weapon,"Battlegrounds.rte"));
              end
              --self.GeneratorsHeavy[i] = self.GeneratorsHeavy[i] - 1
            elseif r <= self.GeneratorsLight[i]+self.GeneratorsHeavy[i] + self.GeneratorsSniper[i] then
              actor = CreateAHuman("Soldier Sniper","Battlegrounds.rte");
              actor:AddInventoryItem(CreateHDFirearm("Sniper Rifle","Battlegrounds.rte"));
            --self.GeneratorsSniper[i] = self.GeneratorsSniper[i] - 1
            else
              actor = CreateAHuman("Heavy Trooper","Battlegrounds.rte");
              local weapon = "Flamer"
              local upgradedweapon = "Napalm Flamer"
              
              if self.FightingCPU == true then
                if self.Generators[i].Team == 0 then
                  if self.Team1players == 0 then
                    if self.Diff >= math.random(0,12) then
                      actor:AddInventoryItem(CreateHDFirearm(upgradedweapon,"Coalition.rte"));
                    else
                      actor:AddInventoryItem(CreateHDFirearm(weapon,"Coalition.rte"));
                    end
                  else
                    if self.Diff * -1 >= math.random(0,12) then
                      actor:AddInventoryItem(CreateHDFirearm(upgradedweapon,"Coalition.rte"));
                    else
                      actor:AddInventoryItem(CreateHDFirearm(weapon,"Coalition.rte"));
                    end
                  end
                else
                  if self.Team2players == 0 then
                    if self.Diff >= math.random(0,12) then
                      actor:AddInventoryItem(CreateHDFirearm(upgradedweapon,"Coalition.rte"));
                    else
                      actor:AddInventoryItem(CreateHDFirearm(weapon,"Coalition.rte"));
                    end
                  else
                    if self.Diff * -1 >= math.random(0,12) then
                      actor:AddInventoryItem(CreateHDFirearm(upgradedweapon,"Coalition.rte"));
                    else
                      actor:AddInventoryItem(CreateHDFirearm(weapon,"Coalition.rte"));
                    end
                  end
                end
              else
                actor:AddInventoryItem(CreateHDFirearm(weapon,"Coalition.rte"));
              end
            --self.GeneratorsHeavyAssault[i] = self.GeneratorsHeavyAssault[i] - 1
            end
            actor.AIMode = Actor.AIMODE_SENTRY
            ;
            actor.Team = self.Generators[i].Team;
            actor.Pos = self.Generators[i].Pos + Vector(0 , 100);
            MovableMan:AddActor(actor);
          end
          self.GeneratorsTimer[i] = self.GeneratorsTimer[i] + 300
        end
      end
    end
    i = i + 1
  end
   -- and (self.FlagsRequired1[i] == 0 or self.TeleporterTeam[self.FlagsRequired1[i]] == 1) 
	for actor in MovableMan.Actors do
    i = 1;
    while i < 9 do
      if self.FlagsActive[i] == true and actor.Pos.X > self.FlagsArea1[i].X and actor.Pos.X < self.FlagsArea2[i].X and actor.Pos.Y > self.FlagsArea1[i].Y and actor.Pos.Y < self.FlagsArea2[i].Y then
        if actor.Team == 0 and self.FlagsCounter[i] < 220 then
          if self.TeleporterTeam[self.FlagsRequired1[i]] == 1 then
            self.FlagsCounter[i] = self.FlagsCounter[i] + 0.5
          end
        elseif actor.Team == 1 and self.FlagsCounter[i] > -220 then
          if self.TeleporterTeam[self.FlagsRequired2[i]] == 2 then
            self.FlagsCounter[i] = self.FlagsCounter[i] - 0.5
          end
        end
--        if actor.Team == 0 and self.FlagsCounter[i] < 220 then
--          self.FlagsCounter[i] = self.FlagsCounter[i] + 0.5
--        elseif actor.Team == 1 and self.FlagsCounter[i] > -220 then
--          self.FlagsCounter[i] = self.FlagsCounter[i] - 0.5
--        end
      end
      i = i + 1
    end
		-- Check for Teleporters
    if actor.Pos.X > self.Teleporterteam1leftarea.X and actor.Pos.X < self.Teleporterteam1leftarea.X + 64 and actor.Pos.Y > self.Teleporterteam1leftarea.Y and actor.Pos.Y < self.Teleporterteam1leftarea.Y + 64 then 
      self:TeleportFindLeft(actor,1)
    end
    if actor.Pos.X > self.Teleporterteam1rightarea.X and actor.Pos.X < self.Teleporterteam1rightarea.X + 64 and actor.Pos.Y > self.Teleporterteam1rightarea.Y and actor.Pos.Y < self.Teleporterteam1rightarea.Y + 64 then 
      self:TeleportFindRight(actor,1)
    end
		-- Check for Teleporters
    if actor.Pos.X > self.Teleporterteam2leftarea.X and actor.Pos.X < self.Teleporterteam2leftarea.X + 64 and actor.Pos.Y > self.Teleporterteam2leftarea.Y and actor.Pos.Y < self.Teleporterteam2leftarea.Y + 64 then 
      self:Teleport2FindLeft(actor,1)
    end
    if actor.Pos.X > self.Teleporterteam2rightarea.X and actor.Pos.X < self.Teleporterteam2rightarea.X + 64 and actor.Pos.Y > self.Teleporterteam2rightarea.Y and actor.Pos.Y < self.Teleporterteam2rightarea.Y + 64 then 
      self:Teleport2FindRight(actor,1)
    end
    
    --Forcefield stuff for this specific map
    if self.TeleporterTeam[4] ~= 1 or self.TeleporterTeam[7] ~= 1  then
      if actor.Pos.X > 3718 and actor.Pos.X < 4099 and actor.Team == 0 then 
        actor.Pos.X = 3717
        local fxa = CreateMOPixel("Force Field Down Glow");
        fxa.Pos = actor.Pos;
        MovableMan:AddParticle(fxa);
      elseif actor.Pos.X > 4099 and actor.Pos.X < 4720 and actor.Team == 0 then 
        actor.Pos.X = 4721
        local fxa = CreateMOPixel("Force Field Down Glow");
        fxa.Pos = actor.Pos;
        MovableMan:AddParticle(fxa);
      end
    end

    if self.TeleporterTeam[3] ~= 2 or self.TeleporterTeam[8] ~= 2  then
      if actor.Pos.X > 7720 and actor.Team == 1 then 
        actor.Pos.X = 7719
        local fxa = CreateMOPixel("Force Field Down Glow");
        fxa.Pos = actor.Pos;
        MovableMan:AddParticle(fxa);
      elseif actor.Pos.X < 712 and actor.Team == 1 then 
        actor.Pos.X = 713
        local fxa = CreateMOPixel("Force Field Down Glow");
        fxa.Pos = actor.Pos;
        MovableMan:AddParticle(fxa);
      end
    end
    
  end
	if self.ActivityState ~= Activity.OVER then
		ActivityMan:GetActivity():SetTeamFunds(0,0)
		if self.FightingCPU and MovableMan:IsActor(self.CPUBrain) == false then
			self.WinnerTeam = self:OtherTeam(self:GetTeamOfPlayer(self.CPUTeam))
			ActivityMan:EndActivity()
		end
		for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
			if self:PlayerActive(player) and self:PlayerHuman(player) then
				-- The current player's team
				local team = self:GetTeamOfPlayer(player)
				-- Check if any player's brain is dead
				if not MovableMan:IsActor(self:GetPlayerBrain(player)) then
					self:SetPlayerBrain(nil, player)
					self:ResetMessageTimer(player)
					FrameMan:ClearScreenText(player)
					FrameMan:SetScreenText("Your brain has been destroyed!", player, 333, -1, false)
					-- Now see if all brains of self player's team are dead, and if so, end the game
					if not MovableMan:GetClosestBrainActor(team) then
						self.WinnerTeam = self:OtherTeam(team)
						ActivityMan:EndActivity()
					end
				end
			end
		end
	end
end